/*
Language.h
*/

#ifndef __LANGUAGE_H
#define __LANGUAGE_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "Utils.h"

#define CMAXLONGLANGUAGE 20

#define LANG_ENGLISH 0
#define LANG_SPANISH 1
#define LANG_CATALA  2
#define LANG_EUSKERA 3
#define MAX_LANG     3
#define LANG_DEFAULT LANG_SPANISH

class Language 
  {
  private:
    int LANGUAGE;
    char stLANGUAGE[CMAXLONGLANGUAGE + 1], stlLANGUAGE[CMAXLONGLANGUAGE + 1];
    const char *getStringEnglish (int WHAT);
    const char *getStringSpanish (int WHAT);    
    const char *getStringCatala  (int WHAT); 
    const char *getStringEuskera  (int WHAT);       
    const char *getImageEnglish (int WHAT);
    const char *getImageSpanish (int WHAT);    
    const char *getImageCatala  (int WHAT);  
    const char *getImageEuskera  (int WHAT);          
    const char *getPageEnglish (int WHAT);
    const char *getPageSpanish (int WHAT);    
    const char *getPageCatala  (int WHAT);  
    const char *getPageEuskera  (int WHAT);          
  public:
    Language (int aLANGUAGE);
    Language (char *pcLANGUAGE); 
    virtual ~Language();
    void setLang (int aLANGUAGE);
    int getLang (void);    
    const char *getStLang (void);
    const char *get  (int WHAT);   
    const char *getI (int WHAT); 
    const char *getPage (int WHAT);
  };

#define MSG_CONNREFUSED        1
#define MSG_CANRECONNECTHERE   2
#define MSG_SERVERISDOWN       3
#define MSG_PERHAPSTIMEOUT     4
#define MSG_CONF_DELETEMAILBOX 5
#define MSG_CONF_EXPUNGE       6
#define MSG_CONF_LOGOUT        7
#define MSG_SEND_OK            8
#define MSG_SEND_ERR           9
#define MSG_CANCELMSG         14
#define MSG_SHOWOPTIONS       15
#define MSG_SAVEOPTIONS       16
#define MSG_CANCELOPTIONS     17
#define MSG_ADDBOOK           18
#define MSG_SAVEADDBOOK       19
#define MSG_ERR_SAVEOPTIONS   21
#define MSG_ERR_SAVEADDBOOK   22
#define MSG_MSGSPURGED        23
#define MSG_MSGSPURGED_S      24
#define MSG_MSGSPURGED_0      25
#define MSG_MAILBOXCHANGED    26
#define MSG_MAILBOXCREATED    27
#define MSG_MAILBOXDELETED    28
#define MSG_MAILBOXRENAMED    29
#define MSG_MOVEDMESSAGES     30
#define MSG_MOVEDMESSAGES_S   31
#define MSG_COPYMESSAGES      32
#define MSG_COPYMESSAGES_S    33
#define MSG_INVALIDPAGE       34
#define MSG_SHOWATTACHS       35
#define MSG_SAVEATTACHS       36
#define MSG_ERASEATTACHS      37
#define MSG_ERR_SAVEATTACHS   38
#define MSG_AB_EDITENTRY      39
#define MSG_AB_SAVEENTRY      40
#define MSG_AB_DELEENTRY      41
#define MSG_AB_ADDTO          42
#define MSG_AB_ADDCC          43
#define MSG_AB_ADDBCC         44            
#define MSG_NO_ENTRIES_MARKED 45
#define MSG_FLAGS_CHANGED     46
#define MSG_FLAGS_CHANGED_S   47
#define MSG_FIELD_TO_EMPTY    48
#define MSG_FIELD_SUBJ_EMPTY  49      
#define MSG_COMPOSE_TIMEOUT   50
#define MSG_TOO_MAX_CONN      51
#define MSG_ERR_SAVE_SENTMAIL 52
#define MSG_TOO_MAX_TRY_CONN  53
#define MSG_ADDRESS_LINE_CUT  54
#define MSG_MIN_TIMEBETWCONNS 55
#define MSG_ERR_RELOAD_ATTACHS 56
#define MSG_NOATTACHSERASED   57
#define MSG_NOATTACHSSAVED    58
#define MSG_NO_ELEMENTS       59
#define MSG_BADCOOKIE         60
#define MSG_DEBUG             61
#define MSG_MALFORMED_MESSAGE 62
#define MSG_MSGSFOUND         63
#define MSG_MSGSFOUND_S       64
#define MSG_MSGSFOUND_0       65
#define MSG_MSGS_SORTED       66
#define MSG_GO_TO_DISABLED    67
#define MSG_AB_ADDFIELDS      68
#define MSG_NNTP_SEND_WARNING 69
#define MSG_MANAGE_NNTPGROUPS 70
#define MSG_NNTPGROUPS_FOUND  71
#define MSG_NNTPGROUPS_ADDED  72
#define MSG_MAX_NNTPGROUPS_FOUND 73
#define MSG_NEW_TO_FORUMS     74

#define L_ATTACHSHOWED     100
#define L_USER             101
#define L_PASSWORD         102 
#define L_LOGIN            103
#define L_CLEAR            104
#define L_LOGOUT           105
#define L_INDEXMAILBOX     106
#define L_CHOOSELANGUAGE   107
#define L_COPYRIGHT        108
#define L_MESSAGES         109
#define L_PREVPAGE_ACT     110
#define L_PREVPAGE_INA     111
#define L_NEXTPAGE_ACT     112
#define L_NEXTPAGE_INA     113
#define L_FIRSTPAGE_ACT    114
#define L_FIRSTPAGE_INA    115
#define L_LASTPAGE_ACT     116
#define L_LASTPAGE_INA     117
#define L_MESSAGE          118
#define L_INDEXMAILBOX2    119
#define L_MESSAGE2         120
#define L_DUMPFULLMSG      121
#define L_NOSUBJECT        122
#define L_NEXTMSG          123
#define L_NEXTMSG_INA      124
#define L_PREVMSG          125
#define L_PREVMSG_INA      126
#define L_ERROR            127
#define L_STRUCTMIME       128
#define L_EXECUTE          129
#define L_DELETEMSG        130
#define L_EXPUNGE          131
#define L_UNDELETEMSG      132
#define L_HELP             133
#define L_COMPOSEMSG       134
#define L_MAILBOXES        135
#define L_CHANGEMAILBOX    136
#define L_CREATEMAILBOX    137
#define L_DELETEMAILBOX    138
#define L_RENAMEMAILBOX    139
#define L_ANSWEREDMSG      140
#define L_UNANSWEREDMSG    141
#define L_FLAGGEDMSG       142
#define L_UNFLAGGEDMSG     143
#define L_SEENMSG          144
#define L_UNSEENMSG        145
#define L_MOVEMSG          148
#define L_COPYMSG          149
#define L_CANCEL           150
#define L_CONFIRM          151
#define L_TO               152
#define L_CC               153
#define L_BCC              154
#define L_SUBJECT          155
#define L_TEXTTOSEND       156
#define L_CANCELMSG        157
#define L_SENDMSG          158
#define L_ATTACHMSG        159
#define L_REPLYMSG         160
#define L_FORWARDMSG       161
#define L_FROM             162
#define L_DATE             163
#define L_REPLYTO          164
#define L_SHOWOPTIONS      166
#define L_ADDBOOK          167
#define L_SAVE             168
#define L_MSGSPERINDEXPAGE 169
#define L_INSIGNINNEWMSG   170
#define L_PERSONALNAME     171
#define L_NOFROM           172
#define L_SIGNATURE        173
#define L_SAVEMSGSENTMAIL  174
#define L_ATTACH_NEW       175
#define L_FILE             176
#define L_NO_ATTACHS       177
#define L_DOATTACH         178
#define L_DETACH           179
#define L_AB_NICKNAME      180
#define L_AB_FULLNAME      181
#define L_AB_ADDRESSES     182
#define L_AB_FCC           183
#define L_AB_COMMENTS      184
#define L_AB_EDITENTRY     185
#define L_AB_NEWENTRY      186
#define L_DELETE           187
#define L_NUMOFENTRIES     188
#define L_BACK             189
#define L_CLEANALL         190
#define L_SAVEADDRESS      191
#define L_NUMBER           192
#define L_FLAGS            193
#define L_SIZE             194
#define L_FLAG_DELETED     195
#define L_FLAG_ANSWERED    196
#define L_FLAG_FLAGGED     197
#define L_FLAG_NEW         198
#define L_FLAG_UNSEEN      199
#define L_MARK             200
#define L_MSGS_AS          201
#define L_PRESS_TO_INDEX   202
#define L_EDIT             203
#define L_SORT             204
#define L_MSGS_SHOWN       205
#define L_INDEXMAILBOX3    206
#define L_LEX_TO           207
#define L_DELNEXTMSG       208
#define L_ABOUT            209
#define L_REPLYFROM        210
#define L_FORWATTACHS      211
#define L_SIZEWRITEAREA    212
#define L_UNDELNEXTMSG     213
#define L_NEXTMSGSHOWN     214
#define L_LASTMSGSHOWN     215
#define L_NUMATTACHSHOW    216
#define L_INDEXMAILBOX4    217
#define L_DOWNLOADMAILBOX  218
#define L_EMPTY_IMAPSERVER 219
#define L_NOTALLOWED_IMAPSERVER 220
#define L_AB_DUMP          221
#define L_TRUNCATELENGTHREADINGMSG 222
#define L_SKIN             223
#define L_SECURITYPROBLEM  224
#define L_REFRESH          225
#define L_FLAG_SEARCHED    226
#define L_SEARCH           227
#define L_REFRESHTIME      228
#define L_SEARCH_SUBJECT   229
#define L_SEARCH_FROM      230
#define L_SEARCH_BODY      231
#define L_SEARCH_ALL       232
#define L_CONFIRMPURGE     233
#define L_CONFIRMLOGOUT    234
#define L_FLAG_UNDELETED   235
#define L_FLAG_UNANSWERED  236
#define L_FLAG_UNFLAGGED   237
#define L_FLAG_UNNEW       238
#define L_FLAG_SEEN        239
#define L_FLAG_UNSEARCHED  240
#define L_SEARCHEDMSG      241
#define L_UNSEARCHEDMSG    242
#define L_DUMPFULLHEADER   243
#define L_ADDADDRESS_TO    244
#define L_ADDADDRESS_CC    245
#define L_ADDADDRESS_BCC   246
#define L_DELADDRESSES     247
#define L_TO0              248
#define L_CC0              249
#define L_BCC0             250
#define L_ADDADDRESS_FIELD 251
#define L_AB_NEWENTRY_S    252
#define L_AB_DUMP_S        253
#define L_REPLYALLMSG      254
#define L_NNTPGROUP        255
#define L_SENDTONNTPGROUP  256
#define L_COMPOSEMSGNNTP   257
#define L_NNTPSERVER       258
#define L_SUBSCRIBEDGROUPS 259
#define L_MANAGE_NNTPGROUPS 260
#define L_LIST_EMPTY       261
#define L_NNTP_LISTSEARCH  262
#define L_GROUPSTOADD      263
#define L_ADDSELECTEDGROUPS 264
#define L_DUMPFULLLIST     265
#define L_FORCEDGROUPS     266
#define L_DISPLAY_UUENCODED 267
#define L_GOSELECTEDGROUP  268
#define L_OP_SHOWCLOCK     269
#define L_ADD_MORE_FORUMS  270
#define L_SORTBYTHREADS    271

#define ERR_INV_CMD              300
#define ERR_INV_USER_PW          301
#define ERR_INV_MAILBOX          302
#define ERR_INV_PARMS            303
#define ERR_OPENCONN             304
#define ERR_CREAT_USERDIR        305
#define ERR_CREAT_USERATTACHSDIR 306
#define ERR_SENDING_MSG          307    
#define ERR_AB_DELEENTRY         308
#define ERR_MAXSIZEATT           309
#define ERR_UNHANDLESIZEATTACH   310
#define ERR_QUOTA_USAGE          311
#define ERR_SERVERISDOWN         312
#define ERR_TESTUSER_ACTIONNOTALLOWED 313
#define ERR_UUDECODING           314
#define ERR_NNTP_NUM_SEL         315

#define ALT_LOGO            500
#define ALT_PREVPAGE_ACT    501
#define ALT_PREVPAGE_INA    502
#define ALT_NEXTPAGE_ACT    503
#define ALT_NEXTPAGE_INA    504
#define ALT_FIRSTPAGE_ACT   505
#define ALT_FIRSTPAGE_INA   506
#define ALT_LASTPAGE_ACT    507
#define ALT_LASTPAGE_INA    508
#define ALT_DUMPFULLMSG     509
#define ALT_NEXTMSG         510
#define ALT_PREVMSG         511
#define ALT_NEXTMSG_INA     512
#define ALT_PREVMSG_INA     513
#define ALT_LOGOUT          514
#define ALT_EXPUNGE         515
#define ALT_HELP            516
#define ALT_COMPOSEMSG      517
#define ALT_MAILBOXES       518
#define ALT_REPLYMSG        519
#define ALT_FORWARDMSG      520
#define ALT_SHOWOPTIONS     522
#define ALT_ADDBOOK         523
#define ALT_BACK            524
#define ALT_SAVEADDRESS     525
#define ALT_SORT            526
#define ALT_AB_NEWENTRY     527
#define ALT_DELNEXTMSG      528
#define ALT_ABOUT           529
#define ALT_UNDELNEXTMSG    530
#define ALT_AB_DUMP         531
#define ALT_DUMPFULLHEADER  532
#define ALT_AB_NEWENTRY_S   533
#define ALT_AB_DUMP_S       534
#define ALT_REPLYALLMSG     535
#define ALT_SENDTONNTPGROUP 536
#define ALT_COMPOSEMSGNNTP  537

#define TIT_COMPOSEMSG     900
#define TIT_HOMEPAGE       901
#define TIT_CONFIRMACTION  902
#define TIT_INDEXMAILBOX   903
#define TIT_MAILBOXES      904
#define TIT_MESSAGEHEADER  905 
#define TIT_REPLYMSG       906
#define TIT_FORWARDMSG     907
#define TIT_SHOWOPTIONS    909
#define TIT_ADDBOOK        910
#define TIT_INVALIDPAGE    911
#define TIT_SHOWATTACHS    912
#define TIT_BADCOOKIE      913
#define TIT_SHOWHEADERS    914
#define TIT_REPLYALLMSG    915
#define TIT_REPLYGROUP     916
#define TIT_COMPOSEMSGNNTP 917
#define TIT_SHOWNNTPMANAGEGROUPS 918

#define PREFIX_REPLY       1100
#define PREFIX_FORWARD     1101

#define FORWARDLINE        1300

#endif











